|  | Home · All Classes · Main Classes · Grouped Classes · Modules · Functions |

# QReadLocker Class Reference
[QtCore module]

The QReadLocker class is a convenience class that simplifies locking and unlocking read-write locks for read access. More...

     #include <QReadLocker>

Note: All the functions in this class are thread-safe.

- List of all members, including inherited members

### Public Functions

- QReadLocker ( QReadWriteLock * lock )
- ~QReadLocker ()
- QReadWriteLock * readWriteLock () const
- void relock ()
- void unlock ()

## Detailed Description

The QReadLocker class is a convenience class that simplifies locking and unlocking read-write locks for read access.

The purpose of QReadLocker (and QWriteLocker) is to simplify QReadWriteLock locking and unlocking. Locking and unlocking statements or in exception handling code is error-prone and difficult to debug. QReadLocker can be used in such situations to ensure that the state of the lock is always well-defined.

Here's an example that uses QReadLocker to lock and unlock a read-write lock for reading:

             QReadWriteLock lock;

             QByteArray readData()
             {
                 QReadLocker locker(&lock);
                 ...
                 return data;
             }

It is equivalent to the following code:

             QReadWriteLock lock;

             QByteArray readData()
             {
                 locker.lockForRead();
                 ...
                 locker.unlock();
                 return data;
             }

The QMutexLocker documentation shows examples where the use of a locker object greatly simplifies programming.

See also QWriteLocker and QReadWriteLock.

## Member Function Documentation

### QReadLocker::QReadLocker ( QReadWriteLock * lock )

Constructs a QReadLocker and locks lock for reading. The lock will be unlocked when the QReadLocker is destroyed. If `lock` is zero, QReadLocker does nothing.

See also QReadWriteLock::lockForRead().

### QReadLocker::~QReadLocker ()

Destroys the QReadLocker and unlocks the lock that was passed to the constructor.

See also QReadWriteLock::unlock().

### QReadWriteLock * QReadLocker::readWriteLock () const

Returns a pointer to the read-write lock that was passed to the constructor.

### void QReadLocker::relock ()

Relocks an unlocked lock.

See also unlock().

### void QReadLocker::unlock ()

Unlocks the lock associated with this locker.

See also QReadWriteLock::unlock().